package de.hdm_stuttgart.mi.sd1.figure.model;

public class Rectangle extends Figure {

// Instance variables representing a rectangle's additional parameters
  private double width, height;
  
   /**
    * Extending {@link Figure#Figure(double, double)} by adding parameters
    * width and height on top of center coordinates.
    * 
    * @param x
    * @param y
    * @param width
    * @param height
    */
   public Rectangle(final double x, final double y, final double width, final double height) {
      super(x, y);
      setWidth(width);
      setHeight(height);
   }
   
   /**
    * @return The rectangle's area.
    */
   public double getArea() {
     return width * height;
   }

   /**
    * @return The rectangle's perimeter.
    */
   public double getPerimeter() {
     return 2 * (width + height); 
   }
   
   // Getter and setter methods for private attributes
   public double getWidth() { return width;}
   public void setWidth(final double width) { this.width = width;}
   public double getHeight() { return height;}
   public void setHeight(final double height) { this.height = height;}

   @Override
   public Figure scale(final double factor) {
      width  *= factor;
      height *= factor;
      return this;
   }  
}